freemarker.template

## Interface TemplateDirectiveModel

All Superinterfaces:
  TemplateModel

All Known Implementing Classes:
  IncludePage

    public interface TemplateDirectiveModel
    extends TemplateModel

"directive" template language data type: used as user-defined directives (much like macros) in templates. They can do arbitrary actions, write arbitrary text to the template output, and trigger rendering of their nested content for any number of times.

They are used in templates like `<@myDirective foo=1 bar="wombat">...</@myDirective>` (or as `<@myDirective foo=1 bar="wombat" />` - the nested content is optional).

Since:
  2.3.11

### Field Summary

### Fields inherited from interface freemarker.template.TemplateModel

`NOTHING`

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `execute(Environment env, Map params, TemplateModel[] loopVars, TemplateDirectiveBody body)` Executes this user-defined directive; called by FreeMarker when the user-defined directive is called in the template.

### Method Detail

#### execute

    void execute(Environment env,
                 Map params,
                 TemplateModel[] loopVars,
                 TemplateDirectiveBody body)
          throws TemplateException,
                 IOException

Executes this user-defined directive; called by FreeMarker when the user-defined directive is called in the template.

Parameters:
  `env` - the current processing environment. Note that you can access the output `Writer` by `Environment.getOut()`.
  `params` - the parameters (if any) passed to the directive as a map of key/value pairs where the keys are `String`-s and the values are `TemplateModel` instances. This is never `null`. If you need to convert the template models to POJOs, you can use the utility methods in the `DeepUnwrap` class.
  `loopVars` - an array that corresponds to the "loop variables", in the order as they appear in the directive call. ("Loop variables" are out-parameters that are available to the nested body of the directive; see in the Manual.) You set the loop variables by writing this array. The length of the array gives the number of loop-variables that the caller has specified. Never `null`, but can be a zero-length array.
  `body` - an object that can be used to render the nested content (body) of the directive call. If the directive call has no nested content (i.e., it's like <@myDirective /> or <@myDirective></@myDirective>), then this will be `null`.
Throws:
  `TemplateException` - If any problem occurs that's not an `IOException` during writing the template output.
  `IOException` - When writing the template output fails.